#include <cstdio>
#include <cstring>

const int dx[] = {1, -1, 0, 0};
const int dy[] = {0, 0, 1, -1};
const int N = 2000;
const int M = 2000;
int n, m, num, color[N][M], p[N * M];
char s[N + 1][M + 1];

bool is_inside(int x, int y) {
	return ((x >= 0) && (x < n) && (y > 0) && (y < m) && (s[x][y] == '.') && (color[x][y] == -1));
}

bool is_border(int x, int y) {
	return ((x == 0) || (x == n - 1) || (y == 0) || (y == m - 1));
}

void dfs(int x, int y, int c) {
	color[x][y] = c;
	for (int d = 0; d < 4; ++d)
		if (is_inside(x + dx[d], y + dy[d]))
			dfs(x + dx[d], y + dy[d], c);
}

int find(int u) {
	return (u == p[u]) ? u : (p[u] = find(p[u]));
}

bool dsu_union(int u, int v) {
	u = find(u), v = find(v);
	p[u] = v;
	return (u != v);
}

int main() {
	scanf("%d%d", &n, &m);
	n = 3 * n, m = 3 * m, num = 1;
	memset(color, -1, sizeof(color));
	for (int i = 0; i < n; ++i)
		scanf("%s", s[i]);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			if ((s[i][j] == '.') && (color[i][j] == -1) && (is_border(i, j)))
				dfs(i, j, 0);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			if ((s[i][j] == '.') && (color[i][j] == -1))
				dfs(i, j, num++);
	for (int i = 0; i < num; ++i)
		p[i] = i;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			if (((j + 1 < m) && (s[i][j] == 'C') && (s[i][j + 1] == 'C') && dsu_union(color[i - 1][j], color[i + 1][j])) ||
                ((i + 1 < n) && (s[i][j] == 'C') && (s[i + 1][j] == 'C') && dsu_union(color[i][j - 1], color[i][j + 1])))
                s[i][j] = '.';
		printf("%s\n", s[i]);
	}
	return 0;
}
