#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <map>
#include <set>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>

using namespace std;

const int nmax = 1e5;
const int inf = 1e9;

vector <int> g[nmax];
vector <int> w[nmax];

int t[nmax];
bool was[nmax];
bool used[nmax];

int n,m;

struct event
{
	int v;
	int d;
	event(int V, int D): v(V), d(D) {};
};

bool operator < (const event& lhs, const event& rhs)
{
	return lhs.d > rhs.d;
}

int dijkstra(int v, int u)
{
	for (int i = 0; i < n; i ++)
		t[i] = inf;
	for (int i = 0; i < n; i ++)
		used[i] = false;
	t[v] = 0;
	priority_queue<event> q;
	q.push(event(v, 0));
	while (q.size() > 0)
	{
		v = q.top().v; q.pop();
		if (used[v]) continue;
		used[v] = 1;
		for (int i = 0; i < g[v].size(); i ++)
		{
			int u = g[v][i];
			int c = w[v][i];
			if (t[v] + c < t[u])
			{
				t[u] = t[v] + c;
				q.push(event(u, t[u]));
			}
		}
	}
	return (t[u] > n) ? -1 : t[u];
}

int main()
{
	cin >> n >> m;
	for (int i = 0; i < m; i ++)
	{
		int x,y;
		cin >> x >> y;
		x --; y --;
		g[x].push_back(y);
		w[x].push_back(0);
		g[y].push_back(x);
		w[y].push_back(1);
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i ++)
	{
		int u,v;
		cin >> u >> v;
		u --; v --;
		cout << dijkstra(u, v) << endl;
	}
	return 0;
}
