#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <map>
#include <set>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>

using namespace std;

const int nmax = 1e3;
const int inf = 1e9;

vector <int> g[nmax];
vector <int> w[nmax];

int t[nmax][nmax];
bool was[nmax];
bool used[nmax];

int n,m;

int dijkstra_naive(int v, int u)
{
	int* T = t[v];
	for (int i = 0; i < n; i ++)
		T[i] = inf;
	for (int i = 0; i < n; i ++)
		used[i] = false;
	T[v] = 0;
	do {
		v = -1;
		int minv = inf;
		for (int i = 0; i < n; i ++)
			if (T[i] < minv && !used[i])
			{
				minv = T[i];
				v = i;
			}
		used[v] = 1;
		if (v != -1)
		{
			used[v] = 1;
			for (int i = 0; i < g[v].size(); i ++)
			{
				int u = g[v][i];
				int c = w[v][i];
				T[u] = min(T[u], T[v] + c);
			}
		}
	}
	while (v != -1);
	return (T[u] > n) ? -1 : T[u];
}

int main()
{
	cin >> n >> m;
	for (int i = 0; i < m; i ++)
	{
		int x,y;
		cin >> x >> y;
		x --; y --;
		g[x].push_back(y);
		w[x].push_back(0);
		g[y].push_back(x);
		w[y].push_back(1);
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i ++)
	{
		int u,v;
		cin >> u >> v;
		u --; v --;
		cout << dijkstra_naive(u, v) << endl;
	}
	return 0;
}
