#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <map>
#include <set>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>

using namespace std;

const int nmax = 3e3;
const int inf = 1e9;

int t[nmax][nmax];

int n,m;

void floyd()
{
	for (int k = 0; k < n; k ++)
		for (int i = 0; i < n; i ++)
			for (int j = 0; j < n; j ++)
				t[i][j] = min(t[i][j], t[i][k] + t[k][j]);
}

int main()
{
	cin >> n >> m;
	for (int i = 0; i < n; i ++)
	{
		for (int j = 0; j < n; j ++)
			t[i][j] = inf;
		t[i][i] = 0;
	}			
	for (int i = 0; i < m; i ++)
	{
		int x,y;
		cin >> x >> y;
		x --; y --;
		t[x][y] = min(t[x][y], 0);
		t[y][x] = min(t[y][x], 1);
	}
	floyd();
	int k;
	cin >> k;
	for (int i = 0; i < k; i ++)
	{
		int u,v;
		cin >> u >> v;
		u --; v --;
		if (t[u][v] > n)
			cout << -1 << endl;			
		else
			cout << t[u][v] << endl;
	}
	return 0;
}
