program solution;

uses
	SysUtils, Math;

type
	Integer = Longint;
	Edge = record
		v, w, next: Integer;
	end;

const
	max_N = 100000;
	inf = 1000000000;

var
	n, m, u, v, k, total, i: Integer;
	start, d: array[1..max_N] of Integer;
	edges: array[1..2 * max_N] of Edge;
	q: array[-max_N..max_N] of Integer;

procedure addEdge(u, v, w: Integer);
begin
	inc(total);
	edges[total].v := v;
	edges[total].w := w;
	edges[total].next := start[u];
	start[u] := total;
end;

function bfs(u, v: Integer): Integer;
var
	qh, qe, i, j: Integer;
begin
	for i := 1 to n do
		d[i] := inf;
	qh := 0;
	qe := 0;
	q[0] := u;
	d[u] := 0;
	while (qh <= qe) do
	begin
		u := q[qh];
		inc(qh);
		j := start[u];
		while (j <> 0) do
		begin
			if (d[edges[j].v] > d[u] + edges[j].w) then
			begin
				d[edges[j].v] := d[u] + edges[j].w;
				if (edges[j].w = 0) then
				begin
					dec(qh);
					q[qh] := edges[j].v;
				end
				else
				begin
					inc(qe);
					q[qe] := edges[j].v;
				end;
			end;
			j := edges[j].next;
		end;
	end;
	bfs := IfThen(d[v] = inf, -1, d[v]);
end;

begin
	fillchar(start, sizeof(start), 0);
	total := 0;
	readln(n, m);
	for i := 1 to m do
	begin
		readln(u, v);
		addEdge(u, v, 0);
		addEdge(v, u, 1);
	end;
	readln(k);
	for i := 1 to k do
	begin
		readln(u, v);
		writeln(bfs(u, v));
	end;
end.
