// Autor: Michał Zgliczyński
// Zadanie: Szatnia

#include <cstring>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#define VAR(i,a) __typeof(a) i = (a)
#define REP(i,n) for(int i=0, _n=(n); i<_n; ++i)
#define FOREACH(i,a) for(VAR(i,(a).begin()); i!=(a).end(); ++i)
#define SIZE(a) ((int)(a).size())
#define ALL(a) (a).begin(),(a).end()
#define PII pair<int, int>
#define VI vector<int>
#define PB push_back
#define ST first
#define ND second
using namespace std;

#include "oi.h"
oi::Random RG;

template <class T> const char *fn(T s, string sub=""){
    ostringstream os;
    os << sub;
    cout << "Generuje ... " << os.str() << endl; 
    return strdup(os.str().c_str());
}

//losowa liczba z przedzialu [minval;maxval]
int rand(int minval, int maxval){
    return (RG.rand()%(maxval-minval+1)) + minval;
}

// losowa liczba z przedzialu [minval;maxval] z wylaczeniem a
int rand(int minval, int maxval, int a){
    int ret;
    do{
        ret = rand(minval, maxval);
    }while(ret==a);
    return ret;
}

struct pytanie{
	int m,k,s;
	int id; // numer zapytania
	bool operator<(const pytanie &a) const{
		return m < a.m;
	}
};

struct plaszcz{
	int c, tp, tz;
	bool operator<(const plaszcz &a) const{
		return tp < a.tp;
	}
};


void wypisz(const char *name, int n, VI &c, VI &tp, VI &tz, int p, VI &m, VI &k, VI &s){
     FILE *f = fopen(name, "w");
     fprintf(f, "%i\n", n);
     REP(i,n){
         fprintf(f, "%i %i %i\n", c[i], tp[i], tz[i]);
     }
     fprintf(f, "%i\n", p);
     REP(i,p){
		 fprintf(f, "%i %i %i\n", m[i], k[i], s[i]);
	 }
     fclose(f);
}

void wypisz(const char *name, int n, plaszcz* zb, int p, pytanie* pytania){
     FILE *f = fopen(name, "w");
     fprintf(f, "%i\n", n);
     REP(i,n){
         fprintf(f, "%i %i %i\n", zb[i].c, zb[i].tp, zb[i].tz);
     }
     fprintf(f, "%i\n", p);
     REP(i,p){
		 fprintf(f, "%i %i %i\n", pytania[i].m, pytania[i].k, pytania[i].s);
	 }
     fclose(f);
}

void gen_ocen1(const char *name, int n, int p){
	RG.setSeed(0);
	VI c,tp,tz,m,k,s;
	REP(i,n) c.PB(rand(1,5)), tp.PB(1 + (i%2)), tz.PB(rand(4, 10));
	REP(i,p) m.PB(rand(1,7)), k.PB(rand(3,3 * n)) ,s.PB(0);
	wypisz(name,n,c,tp,tz,p,m,k,s);
}

void gen_ocen2(const char *name, int n, int p){
	VI c,tp,tz,m,k,s;
	REP(i,n) c.PB(1),tp.PB(i+1),tz.PB(i+3);
	REP(i,p) m.PB(i+1),k.PB(1),s.PB(i%2);
	wypisz(name,n,c,tp,tz,p,m,k,s);
}

void gen_ocen3(const char *name, int n, int p){
	VI c,tp,tz,m,k,s;
	REP(i,n) c.PB(1), tp.PB(1), tz.PB(i+2);
	REP(i,p) m.PB(1), k.PB(i+1), s.PB(i%2);
	wypisz(name,n,c,tp,tz,p,m,k,s);
}

void gen_ocen4(const char *name, int n, int p){
	VI c,tp,tz,m,k,s;
	RG.setSeed(0);
	REP(i,n) c.PB(rand(1,1000)), tp.PB(1), tz.PB(1000000 + rand(1,1000000));
	REP(i,p) m.PB(rand(1,1000000)), k.PB(rand(1,100000)), s.PB(100);
	wypisz(name,n,c,tp,tz,p,m,k,s);
}

const int MAXN = 1000, MAXP = 1000000, MAXK = 100000;
const int inf = 2100000000; // musi byc wieksze od max(m_i + s_i)
plaszcz zbior[MAXN];
pytanie pyt[MAXP];
int F[MAXK+1];
PII G[MAXK+1];
int it = 0; // dla zapytan

void generateQuestions(bool ok, int nrOf, int pos, int i, int eqS = -1){ // czy ma byc ok, ile pytan, ile mozliwych roznych
	if(pos == 1) return;
	RG.randomShuffle(G+1,G+pos);
	if(ok){
		//cout << "robie sobie okejowe, chce ich : " << nrOf << endl;
		//cout << "it : " << it << endl;
		for(int j=1;j<=min(nrOf,pos);j++){
			//printf("zbior[i].tp : %d, G[j].ST-2 : %d\n",zbior[i].tp, G[j].ST-2);
			pyt[it].m = rand(zbior[i].tp,G[j].ST);
			pyt[it].k = G[j].ND;
			if(eqS == -1)pyt[it].s = rand(pyt[it].m, G[j].ST) - pyt[it].m;
			else pyt[it].s = eqS;
			it++;
		}
	}
	else{
		//printf("generuje : %d pytan\n",min(nrOf,pos));
		for(int j = 1; j<= min(nrOf,pos) ; j++){
			//printf("rnd z przedzialu : [%d;%d]\n",zbior[i].tp,G[j].ST-1);
			pyt[it].m = rand(zbior[i].tp,G[j].ST);
			pyt[it].k = G[j].ND;
			if(eqS == -1)pyt[it].s = G[j].ST - pyt[it].m + 20;
			else pyt[it].s = eqS;
			it++;
		}
	}
}

void generateRand(const char *name, int n, int p, int Rseed, int TRAND, int RANDPOOL, int MAXW, int eqS = -1){
	int zap = p / n;
	RG.setSeed(Rseed);
	REP(i,n){
		zbior[i].c = rand(1,MAXW);
		zbior[i].tp = rand(1,TRAND);
		zbior[i].tz = rand(zbior[i].tp +1, zbior[i].tp + TRAND);
	}
	sort(zbior, zbior + n);
	F[0] = inf;
	it = 0;
	REP(i,n){
		//printf("it : %d\n",it);
		for(int j = MAXK; j>= zbior[i].c; j--)
			F[j] = max(F[j] , min(F[j - zbior[i].c], zbior[i].tz));
		REP(j,MAXK+1){
			G[j].ST = F[j];
			G[j].ND = j;
		}
		if(it >= p) continue;
		sort(G,G + MAXK + 1);
		reverse(G, G + MAXK + 1);
		int c = 0;
		while(c < MAXK+1 && G[c].ST >= zbior[i].tp) c++;
		if(p <= n){
			int pos = rand(1,c-1);
			int d = rand(0,RANDPOOL);
			if(d == 0){
				pyt[it].m = rand(zbior[i].tp,G[pos].ST);
				pyt[it].k = G[pos].ND;
				if(eqS == -1)pyt[it].s = rand(pyt[it].m, G[pos].ST) - pyt[it].m;
				else pyt[it].s = eqS;
				it++;
			}
			else if(d <= RANDPOOL/2){
				pyt[it].m = rand(zbior[i].tp,G[pos].ST);
				pyt[it].k = G[pos].ND;
				if(eqS == -1)pyt[it].s = G[pos].ST - pyt[it].m + 20;
				else pyt[it].s = eqS;
				it++;
			}
		}
		else{
			// mozliwych mam c-1 pytan, dodam 
			//printf("befOK\n");
			generateQuestions(1,min(((c-1)/3) +1,zap + 1),c-1,i, eqS);
			//printf("bef !ok\n");
			generateQuestions(0,min(((c-1)/2) +1,zap + 1),c-1,i, eqS);
		}
	}
	RG.randomShuffle(zbior, zbior + n);
	RG.randomShuffle(pyt, pyt + it);
	wypisz(name, n, zbior, it, pyt);
}

void generateRowneTP(const char *name, int n, int p, int Rseed, int TRAND, int RANDPOOL, int MAXW){
	RG.setSeed(Rseed);
	int zap = p / n;
	int tp = rand(1,1000000);
	REP(i,n){
		zbior[i].c = rand(1,MAXW);
		zbior[i].tp = tp;
		zbior[i].tz = rand(zbior[i].tp +1, zbior[i].tp + TRAND);
	}
	sort(zbior, zbior + n);
	F[0] = inf;
	it = 0; // dla zapytan
	REP(i,n){
		for(int j = MAXK; j>= zbior[i].c; j--)
			F[j] = max(F[j] , min(F[j - zbior[i].c], zbior[i].tz));
		REP(j,MAXK+1){
			G[j].ST = F[j];
			G[j].ND = j;
		}
		if(it >= p) continue;
		sort(G,G + MAXK + 1);
		reverse(G, G + MAXK + 1);
		int c = 0;
		while(c < MAXK+1 && G[c].ST >= zbior[i].tp) c++;
		//cout << "c : " << c << endl;
		if(p <= n){
			int pos = rand(1,c-1);
			int d = rand(0,RANDPOOL);
			if(d == 0){
				pyt[it].m = rand(zbior[i].tp,G[pos].ST);
				pyt[it].k = G[pos].ND;
				pyt[it].s = rand(pyt[it].m, G[pos].ST) - pyt[it].m;
				it++;
			}
			else if(d <= RANDPOOL/2){
				pyt[it].m = rand(zbior[i].tp,G[pos].ST);
				pyt[it].k = G[pos].ND;
				pyt[it].s = G[pos].ST - pyt[it].m + 20;
				it++;
			}
		}
		else{
			// mozliwych mam c-1 pytan, dodam 
			//cout << "wielokrotne pytania generuje \n";
			//cout << "min : " << min(((c-1)/3) +1,zap + 1) << endl;
			generateQuestions(1,min(((c-1)/3) +1,zap + 1),c-1,i);
			generateQuestions(0,min(((c-1)/2) +1,zap + 1),c-1,i);
		}
	}
	RG.randomShuffle(zbior, zbior + n);
	RG.randomShuffle(pyt, pyt + it);
	//cout << "stworzylem: " << it << endl;
	wypisz(name, n, zbior, it, pyt);
}

void gen_autor(const char *name){
	RG.setSeed(0);
	int n = 5, p = 5;
	VI c,tp,tz,m,k,s;
	c.PB(6);c.PB(5);c.PB(1);c.PB(2);c.PB(1);
	tp.PB(2);tp.PB(4);tp.PB(2);tp.PB(5);tp.PB(3);
	tz.PB(7);tz.PB(9);tz.PB(4);tz.PB(8);tz.PB(9);
	m.PB(2);m.PB(2);m.PB(3);m.PB(5);m.PB(4);
	k.PB(7);k.PB(7);k.PB(2);k.PB(7);k.PB(1);
	s.PB(1);s.PB(2);s.PB(0);s.PB(2);s.PB(5);
	REP(i,p) m.PB(rand(1,7)), k.PB(rand(3,3 * n)) ,s.PB(0);
	wypisz(name,n,c,tp,tz,p,m,k,s);
}

void generateLong(const char *name){
	RG.setSeed(12);
	int n = 500;
	int p = 10;
	VI c,tp,tz,m,k,s;
	REP(i,n){
		c.PB((i % 3) + 1);
		tp.PB(rand(1,100));
		tz.PB(rand(101,200));
	}
	REP(i,p){
		int M = rand(1,n);
		int K = rand(1,125);
		int S = rand(0,100);
		m.PB(M); k.PB(K); s.PB(S);
	}
	wypisz(name,n,c,tp,tz,p,m,k,s);
}

int main(){
	
	// gen_autor(fn(0,""));
	
	//           nazwa testu,   n,      p,      seed,   deltaT, RANDPOO,MAXW, EQS
	generateRand(fn(1,"002"), 		20, 	10, 	2, 		10000, 	5, 		100);
	
	generateLong(fn(2,"003")); // 500,     10
	
	generateRowneTP(fn(3,"004"), 	777, 	12345, 	45, 	927676, 20, 	678);
	generateRowneTP(fn(4,"005"), 	567, 	54321, 	3245678,456789, 20, 	1000);
	
	generateRand(fn(5,"006"), 		198, 	354321, 	1231,	109900,	20, 	800, 32 );
	generateRand(fn(6,"007"), 		187, 	227345,		21312,	100000,	20, 	700, 45 );
	generateRand(fn(7,"008"), 		200, 	123146, 	12311,	100000,	20, 	600, 48 );
	
	
	generateRand(fn(8,"009"), 49, 712000, 345234, 1000000,40, 1000);
	generateRand(fn(9,"010"), 333, 123321, 49832, 1000000,40, 1000);
	generateRand(fn(10,"011"), 444, 300000, 123, 1000000,40, 1000);
	generateRand(fn(11,"012"), 475, 499000, 523, 1000000,40, 1000);
	generateRand(fn(12,"013"), 500, 500000, 131231, 1000000,40, 1000);
	
    return 0;
}
