#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#ifdef HOME
ifstream in("input.txt");
ofstream out("output.txt");
#else
istream &in = cin;
ostream &out = cout;
#endif

vector<bool> vert;
vector<char> hor;
const int kvert = 4, khor = 5, khorc = 3, kboth = 3;

int n;
string s;

long long vertical()
{
    long long ans = 1;
    for (int i = 0; i < n; ++i) {
        char c = s[i];
        if (c == '*') {
            ans *= kvert - !i;
        } else if (!vert[c] || !i && c == '0') {
            return 0;
        }
    }
    return ans;
}

long long horizontal()
{
    long long ans = 1;
    for (int i = 0; i < n / 2; ++i) {
        char cl = s[i], cr = s[n - i - 1];
        if (cl == '*' && cr == '*') {
            ans *= khor - !i;
        } else if (cr == '*') {
            if (!hor[cl] || !i && cl == '0') {
                return 0;
            }
        } else if (cl == '*') {
            if (!hor[cr] || !i && cr == '0') {
                return 0;
            }
        } else {
            if (!i && cl == '0' || hor[cl] != cr) {
                return 0;
            }
        }
    }
    if (n % 2) {
        char c = s[n / 2];
        if (c == '*') {
            ans *= khorc;
        } else {
            if (hor[c] != c) {
                return 0;
            }
        }
    }
    return ans;
}

long long both()
{
    long long ans = 1;
    for (int i = 0; i < n / 2; ++i) {
        char cl = s[i], cr = s[n - i - 1];
        if (cl == '*' && cr == '*') {
            ans *= kboth - !i;
        } else if (cr == '*') {
            if (hor[cl] != cl || !i && cl == '0') {
                return 0;
            }
        } else if (cl == '*') {
            if (hor[cr] != cr || !i && cr == '0') {
                return 0;
            }
        } else {
            if (!i && cl == '0' || hor[cl] != cl || cl != cr) {
                return 0;
            }
        }
    }
    if (n % 2) {
        char c = s[n / 2];
        if (c == '*') {
            ans *= kboth;
        } else {
            if (hor[c] != c) {
                return 0;
            }
        }
    }
    return ans;
}

int main()
{
    vert.resize(256);
    vert['0'] = vert['1'] = vert['3'] = vert['8'] = true;
    hor.resize(256);
    hor['0'] = '0', hor['1'] = '1', hor['8'] = '8', hor['2'] = '5', hor['5'] = '2';

    in >> n >> s;
    if (n == 1) {
        if (s[0] == '*') {
            out << kvert << endl;
        } else {
            out << int(vert[s[0]]) << endl;
        }
    } else {
        out << horizontal() + vertical() - both() << endl;
    }

    return 0;
}
