import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Map.Entry;
import java.util.TreeMap;


public class python_mp {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		new python_mp().run();
	}

	final int max_priority = 5;
	final int max_sum = 200000;

	class line {
		int level;
		String s;
		line(int tmp) {
			level = tmp;
			s = "";
		}
		line(String data) {
			s = data;
			level = 0;
			while (s.charAt(0) == ' ') {
				level++;
				s = s.substring(1);
			}
			assert(level % 4 == 0);
			level /= 4;
		}
	};

	TreeMap<String, BigInteger> var = new TreeMap<String, BigInteger>();
	TreeMap<String, Integer> ans = new TreeMap<String, Integer>();
	line[] lines;
	int cur_line, cur_level, pos;
	String token, s;

	void initialize_token() {
		s = lines[cur_line].s;
		if (!s.endsWith(":"))
			s = s + ":";
		pos = 0;
	}

	boolean iscompare(char c) {
		return ((c == '>') || (c == '<') || (c == '=') || (c == '!'));
	}
	
	boolean isdigit(char c) {
		return ((c >= '0') && (c <= '9'));
	}
	
	boolean isalpha(char c) {
		return ((c >= 'a') && (c <= 'z')) || ((c >= 'A') && (c <= 'Z'));
	}

	String next_token() {
		while (s.charAt(pos) == ' ')
			++pos;
		token = "";
		if (isdigit(s.charAt(pos))) {
			while (isdigit(s.charAt(pos)))
				token += (s.charAt(pos++));
		} else if (isalpha(s.charAt(pos))) {
			while (isalpha(s.charAt(pos)))
				token += (s.charAt(pos++));
		} else if (iscompare(s.charAt(pos))) {
			while (iscompare(s.charAt(pos)))
				token += (s.charAt(pos++));
		} else
			token += (s.charAt(pos++));
		return token;
	}

	boolean toBool(BigInteger a) {
		return (a.signum() != 0);
	}
	
	BigInteger apply(BigInteger a, BigInteger b, String op) {
		if (ans.get(op) == null)
			ans.put(op, 0);
		ans.put(op, ans.get(op) + 1);
		if (op.equals("+"))
			return a.add(b);
		if (op.equals("-"))
			return a.subtract(b);
		if (op.equals("*"))
			return a.multiply(b);
		if (op.equals(">"))
			return BigInteger.valueOf((a.compareTo(b) > 0) ? 1 : 0);
		if (op.equals("<"))
			return BigInteger.valueOf((a.compareTo(b) < 0) ? 1 : 0);
		if (op.equals("<="))
			return BigInteger.valueOf((a.compareTo(b) <= 0) ? 1 : 0);
		if (op.equals(">="))
			return BigInteger.valueOf((a.compareTo(b) >= 0) ? 1 : 0);
		if (op.equals("=="))
			return BigInteger.valueOf((a.compareTo(b) == 0) ? 1 : 0);
		if (op.equals("!="))
			return BigInteger.valueOf((a.compareTo(b) != 0) ? 1 : 0);
		if (op.equals("or"))
			return BigInteger.valueOf((toBool(a) || toBool(b)) ? 1 : 0);
		return BigInteger.valueOf((toBool(a) && toBool(b)) ? 1 : 0);
	}

	BigInteger apply(BigInteger a, String op) {
		if (ans.get(op) == null)
			ans.put(op, 0);
		ans.put(op, ans.get(op) + 1);
		if (op.equals("-"))
			return a.negate();
		return BigInteger.valueOf(!toBool(a) ? 1 : 0);
	}

	int get_priority(String op) {
		if ((op.equals(":")) || (op.equals("(")) || (op.equals(")")))
			return 0;
		if ((op.equals("and")) || (op.equals("or")))
			return 1;
		if ((op.equals("<")) || (op.equals(">")) || (op.equals("<=")) || (op.equals(">=")) || (op.equals("==")) || (op.equals("!=")))
			return 2;
		if ((op.equals("+")) || (op.equals("-")))
			return 3;
		return 4;
	}

	BigInteger arithmetic_evaluate(int priority) {
		if (priority == max_priority) {
			if (token.equals("(")) {
				next_token();
				BigInteger res = arithmetic_evaluate(1);
				next_token();
				return res;
			} else if ((token.equals("not")) || (token.equals("-"))) {
				String op = token;
				next_token();
				BigInteger res = arithmetic_evaluate(priority);
				return apply(res, op);
			} else if (isalpha(token.charAt(0))) {
				BigInteger res = var.get(token);
				next_token();
				return res;
			} else {
				BigInteger res = new BigInteger(token);
				next_token();
				return res;
			}
		} else {
			BigInteger res = arithmetic_evaluate(priority + 1);
			while (get_priority(token) == priority) {
				String op = token;
				next_token();
				res = apply(res, arithmetic_evaluate(priority + 1), op);
			}
			return res;
		}
	}

	void parse_program(int level) {
		while (lines[cur_line].level == level) {
			initialize_token();
			String command = next_token();
			int start_line = cur_line;
			if ((command.equals("if")) || (command.equals("while"))) {
				next_token();
				cur_line++;
				boolean cond = toBool(arithmetic_evaluate(1));
				if (cond) {
					parse_program(level + 1);
					if (command.equals("while"))
						cur_line = start_line;
				} else while (lines[cur_line].level > level)
					++cur_line;
			} else {
				next_token();
				if (ans.get(token) == null)
					ans.put(token, 0);
				ans.put(token, ans.get(token) + 1);
				next_token();
				if (var.get(command) == null)
					var.put(command, BigInteger.ZERO);
				var.put(command, arithmetic_evaluate(1));
				cur_line++;
			}
		}
	}

	void read_data() throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		//BufferedReader in = new BufferedReader(new FileReader(new File("parser.in")));
		String tmp;
		ArrayList<line> data = new ArrayList<line>();
		while ((tmp = in.readLine()) != null)
			data.add(new line(tmp));
		data.add(new line(-1));
		lines = new line[data.size()];
		int i = 0;
		for (line l: data)
			lines[i++] = l;
		in.close();
	}

	public void run() throws IOException {
		PrintWriter out = new PrintWriter(System.out);
		read_data();
		parse_program(0);
		int sum = 0;
		for (Entry<String, Integer> it: ans.entrySet()) {
			out.println(it.getKey() + ": " + it.getValue());
			sum += it.getValue();
		}
		out.println("total " + sum + " operations");
		out.println();
		for (Entry<String, BigInteger> it: var.entrySet())
			out.println(it.getKey() + ": " + it.getValue());
		out.close();
	}

}
