#include "testlib.h"
#include <string>
#include <ctype.h>
#include <memory.h>
using namespace std;

const int MAX = 52;
int A[MAX][MAX];

int calc(vector<int> p){
    int ans = 0;
    for (int i = 0; i < (int)p.size(); ++i)
        ans += A[i][p[i]];
    return ans;
}

int to_number(char c){
    if ('a' <= c && c <='z')
        return c - 'a';
    else
        return c - 'A' + 26;
}

char to_letter(int i){
    if (i < 26)
        return i + 'a';
    else
        return i - 26 + 'A';
}

int N, K;

bool is_in_alphabet(string & s, int K){
    for (int i = 0; i < (int)s.length(); ++i){
        if (!(isalpha(s[i]) && to_number(s[i]) < K))
            return false;
    }
    return true;
}

vector<int> to_permutation(string s){
    vector<int> res;
    for (int i = 0; i < s.length(); ++i)
        res.push_back(to_number(s[i]));
	for (int i = 0; i < (int) s.length(); ++i)
		for (int j = 0; j < i; ++j)
			if (res[i] == res[j])
				return vector<int>();
    return res;
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);

    memset(A, 0, sizeof(A));
    int N = inf.readInt();
    int K = inf.readInt();
    inf.nextLine();
    string word1 = inf.readString();
    string word2 = inf.readString();
    
    if (word1.length() != N || word2.length() != N)
        quitf(_fail, "Input string lengthes are not equal to N = %d: |s1| = %d, |s2| = %d.", N, word1.length(), word2.length());
        
    for (int i = 0; i < N; ++i){
        int n1 = to_number(word1[i]);
        int n2 = to_number(word2[i]);
        if (n1 + 1 > K)
            quitf(_fail, "On %d position in the first word the letter is not in alphabet K.", i);
        if (n2 + 1 > K)
            quitf(_fail, "On %d position in the second word the letter is not in alphabet K.", i);
        A[n1][n2]++;
    }
    
    int Ares = ans.readInt();
    ans.skipBlanks();
    string Astr = ans.readString();
    
    if (!is_in_alphabet(Astr, K))
        quitf(_fail, "Answer decoding is not correct.");
    
    int Ores = ouf.readInt();
    ouf.skipBlanks();
    string Ostr = ouf.readString();
    
    if (!is_in_alphabet(Ostr, K))
        quitf(_pe, "Decoding contains letter not from alphabet with size K.");

    if (Astr.length() != K)
        quitf(_fail, "In answer decoding there are %d symbols, not %d.", Astr.length(), K);
    
    if (Ostr.length() != K)
        quitf(_pe, "In decoding string there are %d symbols, not %d.", Ostr.length(), K);
    
    vector<int> Operm = to_permutation(Ostr);
    vector<int> Aperm = to_permutation(Astr);
    
    if (Aperm.size() == 0)
        quitf(_fail, "Answer string is not a permutation: %s", Astr.c_str());
    
    if (Operm.size() == 0)
        quitf(_wa, "Decoding contains the same letters, so two different letters are replaced with one common letter: %s", Ostr.c_str());
    
    if (Ares != calc(Aperm))
        quitf(_fail, "The number of mathces for answer decoding is not equal to the number in first line of answer: %d != %d.", calc(Aperm), Ares);
        
    if (Ores != calc(Operm))
        quitf(_wa, "The number of mathces for decoding is not equal to the number in first line of output: %d != %d.", calc(Operm), Ores);
        
    if (Ares > Ores)
        quitf(_wa, "Found answer %d, but the correct answer is %d.", Ores, Ares);
    
    if (Ares < Ores)
        quitf(_fail, "Contestants solution (%d) is better then jury's one (%d).", Ores, Ares);
        
    quitf(_ok, "Correct answer.");
}
