#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <ctime>
#include <cassert>
using namespace std;

const int N = 52;
int A[N + 1][N + 1];
const int INF = 1e8;
int K;

double start_time;

pair<int, vector<int> > solve(){
    int a[N + 1][N + 1];
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j)
            a[i + 1][j + 1] = -A[i][j];
    vector<int> u(N + 1), v(N + 1), p(N + 1), way(N + 1);
    for (int i = 1; i <= K; ++i){
        p[0] = i;
        int j0 = 0;
        vector<int> minv(K + 1, INF);
        vector<char> used(K + 1, false);
        do {
            used[j0] = true;
            int i0 = p[j0], delta = INF, j1;
            for (int j = 1; j <= K; ++j)
                if (!used[j]){
                    int cur = a[i0][j]-u[i0]-v[j];
                    if (cur < minv[j])
                        minv[j] = cur, way[j] = j0;
                    if (minv[j] < delta)
                        delta = minv[j], j1 = j;
                }
            for (int j = 0; j <= K; ++j)
                if (used[j])
                    u[p[j]] += delta, v[j] -= delta;
                else
                    minv[j] -= delta;
            j0 = j1;
        } while (p[j0] != 0);
        do {
            int j1 = way[j0];
            p[j0] = p[j1];
            j0 = j1;
        } while (j0);
    }
    int cost = -v[0];
    vector<int> ans(K);
    for (int j = 1; j <= K; ++j)
        ans[p[j] - 1] = j - 1;
    return make_pair(-cost, ans);
}

int to_number(char c){
    if ('a' <= c && c <='z')
        return c - 'a';
    else
        return c - 'A' + 26;
}

char to_letter(int i){
    if (i < 26)
        return i + 'a';
    else
        return i - 26 + 'A';
}

int main(){
    start_time = clock();
    int n;
    cin >> n >> K;
    string first, second;
    cin >> first >> second;
    
    assert(first.length() == second.length());
    for (int i = 0; i < (int)first.length(); ++i)
        A[to_number(first[i])][to_number(second[i])]++;
    
    pair<int, vector<int> > ans = solve();
    cout << ans.first << endl;
    for (int i = 0; i < K; ++i)
        cout << to_letter(ans.second[i]);
    cout << endl;
    
    cerr << (clock() - start_time) / CLOCKS_PER_SEC << endl;
    return 0;
}
