#include <iostream>
#include <cstdio>
#include <string>
#include <memory.h>
#include <vector>
#include <cassert>
#include <algorithm>
#include <ctime>
using namespace std;

const int N = 52;
int A[N][N];

int usedA[N], usedB[N], was[N];
int usedAsz, usedBsz;
int perm[N], best_perm[N];
int best = -1e9;
int cur = 0;
int order[N][N];
pair<int, pair<int, int> > w_edges[N * N];
double start_time;
int K;

void rec(int v){
    if (v == usedAsz){
        if (cur > best){
            for (int i = 0; i < usedAsz; ++i)
                best_perm[i] = perm[i];
            best = cur;
        }
        return;
    }
    
    int left = min(usedAsz - v, usedBsz - v);
    int max_ans = 0;
    for (int i = 0; i < usedAsz * usedBsz && left > 0; ++i)
        if (w_edges[i].second.first >= v && !was[w_edges[i].second.second])
            max_ans += w_edges[i].first, left--;
    if (left != 0 || max_ans + cur <= best)
        return;
            

    for (int i = 0; i < usedBsz; ++i){
        int next = order[v][i];
        if (!was[next]){
            was[next] = 1;
            perm[v] = next;
            cur += A[usedA[v]][usedB[next]];

            rec(v + 1);

            cur -= A[usedA[v]][usedB[next]];
            was[next] = 0;
        }
    }

    perm[v] = -1;
    rec(v + 1);
}

void prepare(){
    pair<int, int> tmp[N];
    for (int i = 0; i < usedAsz; ++i){
        for (int j = 0; j < usedBsz; ++j)
            tmp[j] = make_pair(A[usedA[i]][usedB[j]], j);
        sort(tmp, tmp + usedBsz);
        reverse(tmp, tmp + usedBsz);
        for (int j = 0; j < usedBsz; ++j)
            order[i][j] = tmp[j].second;
    }
    for (int i = 0; i < usedAsz; ++i)
        for (int j = 0; j < usedBsz; ++j)
            w_edges[i * usedBsz + j] = make_pair(A[usedA[i]][usedB[j]], make_pair(i, j));
    sort(w_edges, w_edges + usedAsz * usedBsz);
    reverse(w_edges, w_edges + usedAsz * usedBsz);
}

pair<int, vector<int> > solve(){
    int wasA[N], wasB[N];
    memset(wasA, 0, sizeof(wasA));
    memset(wasB, 0, sizeof(wasB));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j)
            wasA[i] += A[i][j], wasB[j] += A[i][j];
    for (int i = 0; i < N; ++i){
        if (wasA[i])
            usedA[usedAsz++] = i;
        if (wasB[i])
            usedB[usedBsz++] = i;
    }
    prepare();
    rec(0);
    
    int best_res[N];
    for (int i = 0; i < N; ++i)
        best_res[i] = -1, wasB[i] = 0;
    for (int i = 0; i < usedAsz; ++i)
        if (best_perm[i] != -1)
            best_res[usedA[i]] = usedB[best_perm[i]], wasB[usedB[best_perm[i]]] = 1;
    for (int i = 0, j = 0; i < K && j < K; ++i, ++j){
        while (i < K && best_res[i] != -1)
            i++;
        while (j < K && wasB[j])
            j++;
        if (i == K || j == K){
            assert(i == K && j == K);
            break;
        }
        best_res[i] = j;
    }
    return make_pair(best, vector<int>(best_res, best_res + N));
}


int to_number(char c){
    if ('a' <= c && c <='z')
        return c - 'a';
    else
        return c - 'A' + 26;
}

char to_letter(int i){
    if (i < 26)
        return i + 'a';
    else
        return i - 26 + 'A';
}

int main(){
    start_time = clock();
    int n;
    cin >> n >> K;
    string first, second;
    cin >> first >> second;
    
    assert(first.length() == second.length());
    for (int i = 0; i < (int)first.length(); ++i)
        A[to_number(first[i])][to_number(second[i])]++;
    
    pair<int, vector<int> > ans = solve();
    cout << ans.first << endl;
    for (int i = 0; i < K; ++i)
        cout << to_letter(ans.second[i]);
    cout << endl;
    
    cerr << (clock() - start_time) / CLOCKS_PER_SEC << endl;
    return 0;
}
