#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <memory.h>
using namespace std;

const int N = 120;
const int M = 4 * N * N;

int S, T;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

struct edge
{
    int a, b, f, c, u, nxt;
} E[M];
int first[N];
int ept = 0;
inline void add_edge(int a, int b, int c, int u)
{
    E[ept]     = {a, b, 0, c, u, first[a]};
    E[ept + 1] = {b, a, 0, 0, -u, first[b]};
    first[a] = ept;
    first[b] = ept + 1;
    ept += 2;
}

const int L = 2005000;

char A[L], B[L];

int cnt[N][N];

const int AL = 52;

int prev[N];
int D[N];
int ans = 0;
bool FB()
{
    D[S] = 0;
    for (int i = 1; i <= T; i++)
        D[i] = 1e9;
    for (int it = 0; it <= T; it++)
        for (int e = 0; e < ept; e++)
        {
            if (E[e].f != E[e].c && D[E[e].b] > D[E[e].a] + E[e].u)
                D[E[e].b] = D[E[e].a] + E[e].u, prev[E[e].b] = e;
        }
    if (D[T] >= 1e8)
        return false;
    int mn = 1e9;
    for (int x = T; x != S; x = E[prev[x]].a)
        mn = min(mn, E[prev[x]].c - E[prev[x]].f);
    assert(mn == 1);
    for (int x = T; x != S; x = E[prev[x]].a)
        E[prev[x]].f += mn, E[prev[x] ^ 1].f -= mn, ans += mn * E[prev[x]].u;
    return true;
}

int getc(int x)
{
    return (x < 26) ? 'a' + x : 'A' + x - 26;
}

int getv(char c)
{
    return ('a' <= c && c <= 'z') ? c - 'a' : c - 'A' + 26;
}

int main()
{
    memset(first, -1, sizeof(first));
    int l, k;
    scanf("%d %d ", &l, &k);
    gets(A);
    gets(B);
    assert(l == strlen(A));
    assert(l == strlen(B));
    for (int i = 0; i < l; i++)
        cnt[getv(A[i])][getv(B[i])]++;
    S = 0;
    T = 2 * AL + 1;
    for (int i = 0; i < k; i++)
    {
        add_edge(S, i + 1, 1, 0);
        add_edge(i + AL + 1, T, 1, 0);
        for (int j = 0; j < k; j++)
            add_edge(i + 1, j + AL + 1, 1, -cnt[i][j]);
    }
    while (FB());

    printf("%d\n", -ans);
    for (int i = 1; i <= k; i++)
    {
        int cnt = 0;
        for (int e = first[i]; e != -1; e = E[e].nxt)
        {
            if (E[e].f == 1)
                printf("%c", getc(E[e].b - AL - 1)), cnt++;
        }
        assert(cnt == 1);
    }
    printf("\n");
    return 0;
}
