#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cstring>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <complex>
#include <cassert>
 
using namespace std;
 
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(s) int((s).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define next _next
#define prev _prev
#define rank _rank
#define link _link
 
typedef long long ll;
typedef long long llong;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef complex <double> tc;
 
const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = (1 << 30) - 1;

struct point{
    double x, y;
    point(){}
    point(double _x, double _y){
        x = _x;
        y = _y;
    }
};

struct line{
    double a, b, c;
    line(){}
    line(point &A, point &B){
        a = A.y - B.y;
        b = B.x - A.x;
        c = -a * A.x - b * A.y;
    }
};

int n;
point p[1010];
bool used[1010][1010], checked[1010][1010], res[1010][1010];
int d[1010][1010];

inline bool qq(double a, double b){
    return fabs(a - b) < eps;
}

inline bool lq(double a, double b){
    return b - a > -eps;
}

inline double sqr(double a){
    return a * a;
}

bool operator == (const point &a, const point &b){
    return qq(a.x, b.x) && qq(a.y, b.y);
}

inline int next(int p){
    p++;
    if(p >= n){
        p -= n;
    }
    return p;
}

inline bool in_segm(point &a, point &b, point &c){
    return lq(min(a.x, b.x), c.x) && lq(c.x, max(a.x, b.x)) && lq(min(a.y, b.y), c.y) && lq(c.y, max(a.y, b.y));
}

inline bool bad(point &a, point &b, point &c, point &d){
    line l1 = line(a, b), l2 = line(c, d);
    double D = l1.a * l2.b - l2.a * l1.b;
    if(qq(D, 0)){
        return false;
    }
    point cp = point((l1.b * l2.c - l2.b * l1.c) / D, (l2.a * l1.c - l1.a * l2.c) / D);
    if(cp == c || cp == d){
        return false;
    }
    if(in_segm(a, b, cp) && in_segm(c, d, cp)){
        return true;
    }
    return false;
}

inline double scal(point &a, point &b, point &c){
    return (a.x - b.x) * (c.x - b.x) + (a.y - b.y) * (c.y - b.y);
}

inline double vec(point &a, point &b, point &c){
    return (a.x - b.x) * (c.y - b.y) - (c.x - b.x) * (a.y - b.y);
}

inline double dist(point &a, point &b){
    return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
}

inline int zn(double a){
    if(qq(a, 0)){
        return 0;
    }
    if(a < 0){
        return -1;
    }
    return 1;
}

inline double ang(point &a, point &b, point &c){
    double res = scal(a, b, c) / dist(a, b) / dist(b, c);
    res = min(max(res, double(-1)), double(1));
    return acos(res) * zn(vec(a, b, c));
}

inline bool in_poly(point &cp){
    double sum_ang = 0;
    for(int i = 0; i < n; i++){
        sum_ang += ang(p[i], cp, p[next(i)]);
    }
    return !qq(sum_ang, 0);
}

inline bool check(int a, int b){
    if(checked[a][b]){
        return res[a][b];
    }
    if(checked[b][a]){
        return res[b][a];
    }
    checked[a][b] = true;
    if(next(a) == b || next(b) == a){
        return res[a][b] = true;
    }
    for(int i = 0; i < n; i++){
        if(i != a && i != b && qq(vec(p[a], p[i], p[b]), 0)){
            if(in_segm(p[a], p[b], p[i])){
                return res[a][b] = false;
            }
        }
    }
    for(int i = 0; i < n; i++){
        if(bad(p[i], p[next(i)], p[a], p[b])){
            return res[a][b] = false;
        }
    }
    point cp = point((p[a].x + p[b].x) / 2, (p[a].y + p[b].y) / 2);
    if(in_poly(cp)){
        return res[a][b] = true;
    }
    return res[a][b] = false;
}

int calc(int l, int r){
    if(l == r || next(l) == r){
        return 1;
    }
    if(used[l][r]){
        return d[l][r];
    }
    used[l][r] = true;
    d[l][r] = 0;
    for(int i = next(l); i != r; i = next(i)){
        if(check(l, i) && check(i, r)){
            d[l][r] += calc(l, i) * calc(i, r);
        }
    }
    return d[l][r];
}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen("table.in", "r", stdin);
    //freopen("table.out", "w", stdout);
    scanf("%d", &n);
    for(int i = 0; i < n; i++){
        scanf("%lf %lf", &p[i].x, &p[i].y);
    }
    vector <pii> lst;
    for(int i = 0; i < n - 1; i++){
        for(int j = i + 1; j < n; j++){
            if(next(i) == j || next(j) == i){
                continue;
            }
            if(check(i, j)){
                lst.pb(mp(i, j));
            }
        }
    }
    int ans = calc(0, n - 1) & MOD;
    printf("%d\n", sz(lst));
    for(int i = 0; i < sz(lst); i++){
        printf("%d %d\n", lst[i].fs + 1, lst[i].sc + 1);
    }
    printf("%d\n", ans);
    return 0;
}
