#include <memory.h>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int N = 2000;


int sign(int x)
{
    return (x < 0) ? -1 : x > 0;
}

struct vt
{
    int x, y;
    vt(int _x, int _y)
    {
        x = _x, y = _y;
    }
    vt(){}
    friend vt operator +(vt a, vt b)
    {
        return vt(a.x + b.x, a.y + b.y);
    }
    friend vt operator -(vt a)
    {
        return vt(-a.x, -a.y);
    }
    friend vt operator -(vt a, vt b)
    {
        return vt(a.x - b.x, a.y - b.y);
    }
    friend int operator *(vt a, vt b)
    {
        return a.x * b.x + a.y * b.y;
    }
    friend int operator ^(vt a, vt b)
    {
        return a.x * b.y - b.x * a.y;
    }
} P[N];

int D[N][N];

int n;

inline int mymod(int x)
{
    return x >= n ? x - n : x;
}


bool inter(vt a, vt b, vt c, vt d)
{
    if ((b - a) ^ (d - c))
    {
        return sign((b - a) ^ (c - a)) * sign((b - a) ^ (d - a)) <= 0 &&
               sign((d - c) ^ (b - c)) * sign((d - c) ^ (a - c)) <= 0;
    }
    else
    {
        return (((b - a) ^ (d - a)) == 0) && !((b - a) * (b - a) < min((c - a) * (b - a), (d - a) * (b - a)) || max((c - a) * (b - a), (d - a) * (b - a)) < 0);
    }
}

bool good[N][N];

bool check(int a, int b)
{
    for (int i = 0; i < n; i++)
    {
        if (a == i || a - 1 == i || a - 1 + n == i || b == i || b - 1 == i || b - 1 + n == i)
            continue;
        vt x = P[i], y = P[mymod(i + 1)];
        if (inter(x, y, P[a], P[b]))
            return false;
    
    }
    return true;
}

bool in(vt a, vt b, vt c)
{
    int s = sign(a ^ b);
    if (((c ^ a) == 0 && (c * a) > 0) || ((c ^ b) == 0 && (c * b) > 0))
        return false;
    if (s >= 0)
        return (a ^ c) > 0 && (c ^ b) > 0;
    else 
        return !in(b, a, c);
}

int get(int l, int r)
{
    if (l == r || mymod(l + 1) == r)
        return 1;
    if (D[l][r] != -1)
        return D[l][r];
    D[l][r] = 0;
    for (int i = mymod(l + 1); i != r; i = mymod(i + 1))
        if (good[l][i] && good[i][r])
            D[l][r] += get(l, i) * get(i, r);
    return D[l][r];
}

int main()
{
    memset(D, -1, sizeof(D));
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d %d", &P[i].x, &P[i].y);
    int S = 0;
    for (int i = 0; i < n; i++)
        S += P[i] ^ P[mymod(i + 1)];
    bool rev = false;
    if (S < 0)
    {
        reverse(P, P + n);
        rev = true;
    }
    vector<pair<int, int> > I;
    for (int i = 0; i < n; i++)
        good[i][mymod(i + 1)] = good[mymod(i + 1)][i] = 1;
    for (int a = 0; a < n; a++)
        for (int b = a + 1; b < n; b++)
            if (check(a, b) && in(P[mymod(a + 1)] - P[a], P[mymod(a + n - 1)] - P[a], P[b] - P[a]))
            {
                good[a][b] = good[b][a] = 1;
                if (mymod(a + 1) != b && mymod(b + 1) != a)
                    I.push_back((rev) ? make_pair(n - 1 - b, n - 1 - a) : make_pair(a, b));
            }
    sort(I.begin(), I.end());
    printf("%d\n", I.size());
    for (int i = 0; i < I.size(); i++)
        printf("%d %d\n", 1 + I[i].first, 1 + I[i].second);
    printf("%d\n", get(0, n - 1) & (-1 + (1 << 30)));
    return 0;
}
